#include <unistd.h>
#include <errno.h>

#ifdef __linux__
#include <linux/limits.h>
#endif

int gpm_close_all(void)
{
	int fd, max;

	max = sysconf(_SC_OPEN_MAX);
	if (max <= 0)
		return -1;

#ifdef __linux__
	if (max < NR_OPEN)
		max = NR_OPEN;
#endif

	for (fd = 3; fd < max; fd++) {
		if (close(fd) && errno != EBADF)
			return -1;
	}

	return 0;
}
